unit u_client;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ExtCtrls,jpeg,Sockets, ComCtrls, ToolWin,
  Buttons, Menus;

type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    Panel2: TPanel;
    Image1: TImage;
    ControlBar1: TControlBar;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    ToolBar5: TToolBar;
    StatusBar1: TStatusBar;
    N4: TMenuItem;
    N5: TMenuItem;
    Timer2: TTimer;
    MainMenu1: TMainMenu;
    N6: TMenuItem;
    N161: TMenuItem;
    N2561: TMenuItem;
    N7: TMenuItem;
    MainMenu2: TMainMenu;
    N2331: TMenuItem;
    N231: TMenuItem;
    ToolBar4: TToolBar;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    N32: TMenuItem;
    N33: TMenuItem;
    N34: TMenuItem;
    N35: TMenuItem;
    N36: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure N3Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1DblClick(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure N161Click(Sender: TObject);
    procedure N2561Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
  private
    { Private declarations }
    ist_picstream:TMemoryStream ;
    jpegscreen:Tjpegimage;
    ib_receive,ib_transok,ib_mcontral:boolean;
    ii_orginamx,ii_orginamy,ii_mcurrentx,ii_mcurrenty:integer;
    li_viewmode,ii_movecount,ii_dragcount:integer;
    ls_viewmode,is_btstate,is_dragstate:string;
    ibu_button: TMouseButton;
    function uf_formatxy(ai_x,ai_y:integer):string;
    procedure up_senddrag(x,y:integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses about;
const BLOCKSIZE= 2048;
const C_SHOW= '00005';
const C_CLOSE= '00006';
const C_DISCONNECT= '00007';
const C_EXEC= '00008';
const C_NOP= '00009';
const C_MOUSE= '00010';
const C_RESET= '00011';
const M_NONE= '000';
const M_LEFTDOWN= '001';
const M_RIGHTDOWN= '002';
const M_LEFTUP= '003';
const M_RIGHTUP= '004';
const M_EVENT_LEFT_CLK= '001';
const M_EVENT_RIGHT_CLK= '002';
const M_EVENT_LEFT_BEGINDRAG= '003';
const M_EVENT_LEFT_DRAGING= '004';
const M_EVENT_LEFT_ENDDRAG= '005';
const M_EVENT_RIGHT_BEGINDRAG= '006';
const M_EVENT_RIGHT_DRAGING= '007';
const M_EVENT_RIGHT_ENDDRAG= '008';
const M_EVENT_DBLCLK= '009';
const M_EVENT_MOVE= '010';
const S_BEGINDRAG='0';
const S_DRAGING='1';
const S_NONE='2';
{$R *.dfm}
function TForm1.uf_formatxy(ai_x,ai_y:integer):string;
var
ls_tmp,ls_x,ls_y:string;
begin
        ls_tmp:='00000'+inttostr(ai_x) ;
        ls_x:=copy(ls_tmp,length(ls_tmp)-5+1,5);
        ls_tmp:='00000'+inttostr(ai_y) ;
        ls_y:=copy(ls_tmp,length(ls_tmp)-5+1,5);
        result:=ls_x+ls_y;
end;
procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
li_actbyte:integer;
lb_tmpbuff:array[0..BLOCKSIZE] of char;
begin
  li_actbyte:=Socket.ReceiveLength;
  Socket.ReceiveBuf(lb_tmpbuff,li_actbyte);
  ist_picstream.Write(lb_tmpbuff,li_actbyte);
  StatusBar1.Panels[2].Text:='ǿ餤...';
  Timer2.Enabled:=false;
  Timer2.Enabled:=true;
  if li_actbyte<BLOCKSIZE then
  begin
        ist_picstream.Position:=0;
        jpegscreen.LoadFromStream(ist_picstream);
        image1.Picture.Bitmap.Assign(jpegscreen);
        StatusBar1.Panels[2].Text:='ǿ駹'+inttostr(ist_picstream.Size);
        ist_picstream.Clear;
        socket.SendText(C_NOP);
        ib_transok:=true;
        Timer2.Enabled:=false;
        Timer2.Enabled:=true;
        ls_viewmode:=inttostr(li_viewmode);
  end
  else
        socket.SendText(C_SHOW+ls_viewmode);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Panel2.Width:=screen.Width;
Panel2.Height:=screen.Height;
ii_movecount:=0;
is_dragstate:=S_NONE;
ii_dragcount:=0;
ib_receive:=true;
ib_mcontral:=false;
li_viewmode:=4;
ls_viewmode:='4';
ist_picstream:=TMemoryStream.Create;
ist_picstream.Clear;
ist_picstream.Position:=0;
jpegscreen:=Tjpegimage.Create ;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.Panels[0].Text:=Socket.RemoteAddress;
  StatusBar1.Panels[1].Text:='s\!!!';
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
StatusBar1.Panels[1].Text:='s_}';
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
ClientSocket1.Socket.SendText(C_DISCONNECT);
ClientSocket1.Active:=false;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
ls_filename:string;
begin
 if InputQuery('J','Jݰ檺{',ls_filename) then
ClientSocket1.Socket.SendText(C_EXEC+ls_filename);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if ib_transok then
begin
        ClientSocket1.Socket.SendText(C_SHOW+ls_viewmode);
        ib_receive:=true;
        ib_transok:=false;
end;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
ClientSocket1.Socket.SendText(C_CLOSE);
end;

procedure TForm1.N2Click(Sender: TObject);
begin
ClientSocket1.Socket.SendText(C_RESET);
end;
procedure TForm1.up_senddrag(x,y:integer);
var
ls_event,ls_tmp,ls_xy:string;
begin
    if is_dragstate=S_NONE then
    begin
        is_dragstate:=S_BEGINDRAG;
        if (is_btstate=M_LEFTDOWN) then
                ls_event:= M_EVENT_LEFT_BEGINDRAG
        else
                ls_event:= M_EVENT_RIGHT_BEGINDRAG ;
        ls_xy:=uf_formatxy(x,y);
        ClientSocket1.Socket.SendText(C_MOUSE+ls_event+ls_xy);
    end
    else if (is_dragstate=S_DRAGING) or (is_dragstate=S_BEGINDRAG) then
    begin
        is_dragstate:=S_DRAGING;
        inc(ii_dragcount);
        if ii_dragcount>4 then
        begin
                if (is_btstate=M_LEFTDOWN) then
                        ls_event:= M_EVENT_LEFT_DRAGING
                else
                        ls_event:= M_EVENT_RIGHT_DRAGING;
                ls_xy:=uf_formatxy(x,y);
                ClientSocket1.Socket.SendText(C_MOUSE+ls_event+ls_xy);
                ii_dragcount:=0;
        end;
    end;
end;
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
ls_event,ls_tmp,ls_xy:string;
begin
        ii_mcurrentx:= x;
        ii_mcurrenty:=y;
        if (is_btstate=M_LEFTDOWN) or (is_btstate=M_RIGHTDOWN) then
                up_senddrag(x,y)
        else
        begin
                inc(ii_movecount);
                if ii_movecount>10 then
                begin
                        ii_movecount:=0;
                        ls_event:= M_EVENT_MOVE ;
                        ls_xy:=uf_formatxy(x,y);
                        ClientSocket1.Socket.SendText(C_MOUSE+ls_event+ls_xy);
                end;
        end;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
ClientSocket1.Socket.SendText(C_DISCONNECT);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
ls_event,ls_tmp:string;
begin
  if Button=mbLeft then
  begin
        is_btstate:=M_LEFTDOWN;
  end
  else if Button=mbright then
  begin
        is_btstate:=M_RIGHTDOWN;
  end ;
  ii_orginamx:=x;
  ii_orginamy:=y;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
ls_event,ls_tmp,ls_xy:string;
begin
        if (Button=mbleft)  then
        begin
                if is_dragstate=S_NONE then
                        ls_event:= M_EVENT_LEFT_CLK
                else if (is_dragstate=S_BEGINDRAG)or(is_dragstate=S_DRAGING) then
                        ls_event:= M_EVENT_LEFT_ENDDRAG ;
        end
        else if (Button=mbright) then
        begin
               if is_dragstate=S_NONE then
                        ls_event:= M_EVENT_RIGHT_CLK
               else if (is_dragstate=S_BEGINDRAG)or(is_dragstate=S_DRAGING) then
                        ls_event:= M_EVENT_RIGHT_ENDDRAG ;
         end ;
         ls_xy:=uf_formatxy(x,y);
         ClientSocket1.Socket.SendText(C_MOUSE+ls_event+ls_xy);
         ii_mcurrentx:=X;
         ii_mcurrentY:=Y;
         is_dragstate:=S_NONE;
         ii_dragcount:=0;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
var
ls_event,ls_xy:string;
begin
        ls_event:= M_EVENT_DBLCLK;
        ls_xy:=uf_formatxy(ii_mcurrentx,ii_mcurrenty);
        ClientSocket1.Socket.SendText(C_MOUSE+ls_event+ls_xy);
end;
procedure TForm1.N5Click(Sender: TObject);
var
ls_filename:string;
begin
 if InputQuery('J','ݭn檺{',ls_filename) then
ClientSocket1.Socket.SendText(C_EXEC+ls_filename);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
        Timer1.Enabled:=true;
        ib_receive:=true;
        ib_transok:=true;
end;

procedure TForm1.RadioButton4Click(Sender: TObject);
begin
li_viewmode:=1;
end;

procedure TForm1.N161Click(Sender: TObject);
begin
  tmenuitem(Sender).Checked:=true;
  li_viewmode:=2;
end;

procedure TForm1.N2561Click(Sender: TObject);
begin
  tmenuitem(Sender).Checked:=true;
  li_viewmode:=3;
end;

procedure TForm1.N7Click(Sender: TObject);
begin
  tmenuitem(Sender).Checked:=true;
  li_viewmode:=4;
end;

procedure TForm1.N9Click(Sender: TObject);
begin
        Timer1.Enabled:=true;
        ib_receive:=true;
        ib_transok:=true;
end;

procedure TForm1.N10Click(Sender: TObject);
begin
       Timer1.Enabled:=false;
       ib_receive:=false;
end;

procedure TForm1.N12Click(Sender: TObject);
begin
tmenuitem(sender).Checked:=true;
Timer1.Interval:=strtoint(copy(tmenuitem(sender).caption,4,1))*1000;
end;

procedure TForm1.N14Click(Sender: TObject);
var
ls_server:string;
begin
  if inputquery('','пJnsAȾW',ls_server) then
  begin
        ClientSocket1.Host:=ls_server;
        ClientSocket1.Port:=strtoint('3624');
        ClientSocket1.Active:=true;
  end;
end;

procedure TForm1.N15Click(Sender: TObject);
begin
  ClientSocket1.Socket.SendText(C_DISCONNECT);
end;

procedure TForm1.N17Click(Sender: TObject);
begin
ClientSocket1.Socket.SendText(C_CLOSE);
end;

procedure TForm1.N16Click(Sender: TObject);
begin
ClientSocket1.Socket.SendText(C_RESET);
end;

procedure TForm1.N18Click(Sender: TObject);
begin
  AboutBox.Show;
end;

end.
